/*
  $Id: ActionReply.java,v 1.2 2006/09/08 14:37:41 admin Exp $
  -----
	
  SSTP Bottle Client for MacOS X, using protocol SLPP2.0
  Copyright (C) 2001-2002 phonohawk.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package action;
import java.util.*;

public class ActionReply {
    Hashtable commands;
    Hashtable remarks;

    public ActionReply() {
		this.commands = new Hashtable();
		this.remarks = new Hashtable();
    }

    public void setDrop(boolean also_from_log) {
		// この瓶を破棄するやうに設定する。
		// also_from_logが眞であれば、ログにすら記録されない。(リプレイ時には無視される)
		commands.put("drop",also_from_log ? "also-from-log" : "retain-log");
    }

    public int getDrop() {
		String drop = (String)commands.get("drop");
		if (drop == null) {
			return 0; // 破棄しない。
		}
		else if (drop.equals("retain-log")) {
			return 1; // ログには保存しておく。
		}
		else if (drop.equals("also-from-log")) {
			return 2; // ログからも破棄
		}
		return 0;
    }

    public void setStopAction() {
		// この瓶に關しては、ここでアクション處理は停止し、以降のフィルタをスキップする。
		commands.put("stop-action", "true");
    }

    public boolean getStopAction() {
		String stop = (String)commands.get("stop-action");
		if (stop == null) {
			return false;
		}
		else {
			return stop.equals("true");
		}
    }

    public void setIfGhostForSSTPServer(String ifghost) {
		// この瓶をSSTPサーバーに送る際、IfGhostを別の物に設定する。
		commands.put("ifghost-for-sstp-server", ifghost);
    }

    public String getIfGhostForSSTPServer() {
		return (String)commands.get("ifghost-for-sstp-server");
    }

    public Hashtable getCommands() {
		return commands; // 變更しないこと。
    }

    public Hashtable getRemarks() {
		return remarks; // 變更しないこと。
    }

    public void setCommands(Hashtable commands) {
		this.commands.putAll(commands);
    }

    public void setRemarks(Hashtable remarks) {
		this.remarks.putAll(remarks);
    }
}
