/*  $Id: GroupListDataSource.java,v 1.2 2006/09/08 14:37:42 admin Exp $
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2004 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui.logbrowser;
import gui.logbrowser.*;
import log.*;
import core.*;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class GroupListDataSource implements NSTableView.DataSource {
    // implementaion of NSTableView.DataSource
    public int numberOfRowsInTableView(NSTableView aTableView) {
        LogData holded = LogDataServer.sharedLogServer().getHolded();
        
		if (holded == null) {
			return 0;
		}
        
        return holded.getGroups().size();
    }
	
    public boolean tableViewAcceptDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
        // optional
        return false;
    }
	
    public Object tableViewObjectValueForLocation(
        NSTableView aTableView,
        NSTableColumn aTableColumn,
        int rowIndex) {
		String column = (String)aTableColumn.identifier();
	
        LogData holded = LogDataServer.sharedLogServer().getHolded();
		Vector groups = holded.getGroups(); // <Object[]> , [0]:(String)name [1]:(Vector)bottles
	
		Object[] entry = (Object[])groups.elementAt(rowIndex);
		String name = (String)entry[0];
		Vector bottles = (Vector)entry[1];
	
        if (column.equals("quantity")) {
			return Integer.toString(bottles.size());
		}
		else if (column.equals("group")) {
			return name;
		}
		else {
			return null;
		}
    }
    
    public void tableViewSetObjectValueForLocation(
        NSTableView aTableView,
        Object anObject,
        NSTableColumn aTableColumn,
        int rowIndex) {
        // do nothing
    }
    
    public int tableViewValidateDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
        // optional
        return 0;
    }
    
    public boolean tableViewWriteRowsToPasteboard(
        NSTableView tableView,
        NSArray rows,
        NSPasteboard pboard) {
        // optional
        return false;
    }

    public void tableViewSortDescriptorsDidChange(
		NSTableView tableView,
		NSArray array) {
		// optional
    }

	public NSArray tableViewNamesOfPromisedFilesDroppedAtDestination(
		NSTableView tableView,
		java.net.URL url,
		NSIndexSet indexSet) {
		// optional
		return null;
	}

	public boolean tableViewWriteRowsToPasteboard(
		NSTableView tableView,
		NSIndexSet indexSet,
		NSPasteboard pboard) {
		// optional
		return false;
	}
}