/*
  $Id: ChannelInfoViewDataSource.java,v 1.2 2006/09/08 14:37:42 admin Exp $
  -----
	
  SSTP Bottle Client for MacOS X, using protocol SLPP2.0
  Copyright (C) 2001-2002 phonohawk.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui.main;
import gui.main.*;
import core.*;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class ChannelInfoViewDataSource implements NSTableView.DataSource {
    public int numberOfRowsInTableView(NSTableView aTableView) {
		if (!Foundation.sharedFoundation().slpp_connected()) return 0;
        
		Vector chList = Foundation.sharedFoundation().getSlppConnection().getChannelList();
		if (chList == null) return 0;
        
		return chList.size();
	}
    
    public boolean tableViewAcceptDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
		// optional
		return false;
	}
    
    public Object tableViewObjectValueForLocation(
        NSTableView aTableView,
        NSTableColumn aTableColumn,
        int rowIndex) {
		if (!Foundation.sharedFoundation().slpp_connected()) return null;
        
		Vector chList = Foundation.sharedFoundation().getSlppConnection().getChannelList();
		if (chList == null) return null;
        
		ChannelInfo info = (ChannelInfo)chList.elementAt(rowIndex);
		String column = (String)aTableColumn.identifier();
		String result;
        
		if (column.equals("Ch#")) {
			result = ""+(rowIndex+1);
		}
		else if (column.equals("Name")) {
			result = info.name();
		}
		else if (column.equals("Info")) {
			result = info.info();
		}
		else if (column.equals("Count")) {
			result = ""+info.count();
		}
		else if (column.equals("Ghost")) {
			result = info.ghost();
		}
		else if (column.equals("NoPost")) {
			result = (info.nopost() ? "@" : "");
		}
		else {
			result = "";
		}
        
		if (info.registered()) {
			NSMutableAttributedString mas = new NSMutableAttributedString(result);
			mas.addAttributeInRange(
				NSAttributedString.ForegroundColorAttributeName,
				NSColor.redColor(),
				new NSRange(0,mas.length())
				);
			return mas;
		}
		else {
			return result;
		}
	}
    
    public void tableViewSetObjectValueForLocation(
        NSTableView aTableView,
        Object anObject,
        NSTableColumn aTableColumn,
        int rowIndex) {
		// do nothing
	}
    
    public int tableViewValidateDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
		// optional
		return 0;
	}
    
    public boolean tableViewWriteRowsToPasteboard(
        NSTableView tableView,
        NSArray rows,
        NSPasteboard pboard) {
		// optional
		return false;
	}

	public boolean tableViewWriteRowsToPasteboard(
		NSTableView tableView,
		NSIndexSet indexSet,
		NSPasteboard pboard) {
		// optional
		return false;
	}

    public void tableViewSortDescriptorsDidChange(
		NSTableView tableView, NSArray oldDescriptors) {
		// optional
    }

	public NSArray tableViewNamesOfPromisedFilesDroppedAtDestination(
		NSTableView tableView,
		java.net.URL url,
		NSIndexSet indexSet) {
		// optional
		return null;
	}
}
