/*
	$Id: MainWindowGhostComboDataSource.java,v 1.1.1.1 2003/04/08 14:55:46 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui.main;
import gui.main.*;
import gui.pref.*;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class MainWindowGhostComboDataSource implements NSComboBox.DataSource
{
    public static final String DEFAULT_ITEM = "# Default #";
    Vector ghosts;
    
    public MainWindowGhostComboDataSource()
    {
		reloadFromDefaults();
    }
    
    public void reloadFromDefaults()
    {
		NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
		NSArray array = defaults.arrayForKey("ghostspec.table");
		if (array == null) {
			ghosts = PrefWindowController.createDefaultGhostNamesArray();
		}
		else {
			ghosts = newVectorFromNSArray(array);
		}
    }
	
	public static Vector newVectorFromNSArray(NSArray array)
    {
		final int size_array = array.count();
		Vector vec = new Vector(size_array);
		for (int i = 0; i < size_array; i++) {
			vec.add(array.objectAtIndex(i));
		}
		return vec;
    }
    
    // implementation of NSComboBox.DataSource
    public int numberOfItemsInComboBox(NSComboBox aComboBox)
    {
		return ghosts.size() + 1;
    }
    
    public String comboBoxCompletedString( NSComboBox aComboBox, String aString)
    {
		return null; // optional
    }
    
    public int comboBoxIndexOfItem( NSComboBox aComboBox, String aString)
    {
		return NSArray.NotFound; // optional
    }
    
    public Object comboBoxObjectValueForItemAtIndex( NSComboBox aComboBox, int index)
    {
		return (index == 0 ? DEFAULT_ITEM : ghosts.elementAt(index-1));
    }
}
