/*
  $Id: PrefGhostSpecTableDataSource.java,v 1.2 2006/09/08 14:37:42 admin Exp $
  -----
	
  SSTP Bottle Client for MacOS X, using protocol SLPP2.0
  Copyright (C) 2001-2002 phonohawk.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui.pref;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class PrefGhostSpecTableDataSource implements NSTableView.DataSource {
    Vector ghosts; // Contents : (String)ゴースト名
    
    public PrefGhostSpecTableDataSource() {
		// defaultsから取得する。
		ghosts = new Vector();
	}
    
    public void setArray(Vector array) {
		// 引数から取得する。
		// 外部からこれを呼んだ時は必ずその直後にNSTableViewにreloadData()を発行して下さい。
		ghosts.clear();
		ghosts.addAll(array);
	}
    
    public Vector getArray() {
		return ghosts;
	}
    
    public void addItem() {
		ghosts.add("");
	}
    
    public void removeItemAtIndex(int index) {
		ghosts.remove(index);
	}
    
    // implementaion of NSTableView.DataSource
    public int numberOfRowsInTableView(NSTableView aTableView) {
		return ghosts.size();
	}
    
    public boolean tableViewAcceptDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
		// optional
		return false;
	}
    
    public Object tableViewObjectValueForLocation(
        NSTableView aTableView,
        NSTableColumn aTableColumn,
        int rowIndex) {
		return ghosts.elementAt(rowIndex);
	}
    
    public void tableViewSetObjectValueForLocation(
        NSTableView aTableView,
        Object anObject,
        NSTableColumn aTableColumn,
        int rowIndex) {
		ghosts.setElementAt(anObject,rowIndex);
	}
    
    public int tableViewValidateDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
		// optional
		return 0;
	}
    
    public boolean tableViewWriteRowsToPasteboard(
        NSTableView tableView,
        NSArray rows,
        NSPasteboard pboard) {
		// optional
		return false;
	}

    public void tableViewSortDescriptorsDidChange(
		NSTableView tableView, NSArray oldDescriptors) {
		// optional
    }

	public NSArray tableViewNamesOfPromisedFilesDroppedAtDestination(
		NSTableView tableView,
		java.net.URL url,
		NSIndexSet indexSet) {
		// optional
		return null;
	}

	public boolean tableViewWriteRowsToPasteboard(
		NSTableView tableView,
		NSIndexSet indexSet,
		NSPasteboard pboard) {
		// optional
		return false;
	}
}
