/*
  $Id: YenURLAssistantController.java,v 1.2 2006/09/08 14:37:42 admin Exp $
  -----
	
  SSTP Bottle Client for MacOS X, using protocol SLPP2.0
  Copyright (C) 2001-2002 phonohawk.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui.yenurl;
import gui.yenurl.*;
import gui.main.*;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class YenURLAssistantController extends NSWindowController {
    private static YenURLAssistantController _sharedInstance = null;
    
    private YenURLAssistantSubview currentSubview;
    
    NSButton main_btn_enter;
    NSView main_view_root;
    YenURLAssistantYNStyleView view_ynstyle;
    YenURLAssistantTableStyleView view_tablestyle;
    
    public static YenURLAssistantController sharedController() {
		if (_sharedInstance == null) {
			_sharedInstance = new YenURLAssistantController();
		}
		return _sharedInstance;
	}
    
    private YenURLAssistantController() {
		super("YenURLWindow");
		loadWindow();
		
		window().setFrameUsingName("yenUrlAssistant_frame");
		window().setFrameAutosaveName("yenUrlAssistant_frame");
		
		view_ynstyle.setup();
		view_tablestyle.setup();
		
		main_view_root.addSubview(view_ynstyle);
		currentSubview = view_ynstyle;
		main_btn_enter.setEnabled(false);
	}
    
    public void main_changeStyle(NSMatrix sender) {
		switch (sender.selectedCell().tag()) {
		case 0: // Y/N Style
			if (currentSubview != view_ynstyle) {
				view_tablestyle.removeFromSuperview();
				main_view_root.addSubview(view_ynstyle);
				
				currentSubview = view_ynstyle;
			}
			break;
			
		case 1: // Table Style
			if (currentSubview != view_tablestyle) {
				view_ynstyle.removeFromSuperview();
				main_view_root.addSubview(view_tablestyle);
				
				currentSubview = view_tablestyle;
			}
			break;
		}
		currentSubview.validate();
	}

    public void main_enter(Object sender) {
		String tag = currentSubview.generateYenURLTag();
		if (tag == null) return;
		
		MainWindowController.sharedInstance().insertTextToScriptView(tag);
	}

    public void main_resetAll(Object sender) {
		view_ynstyle.resetAll();
		view_tablestyle.resetAll();
	}
    
    public void setEnabledOfEnterButton(boolean bool) {
		main_btn_enter.setEnabled(bool);
	}
    
    public interface YenURLAssistantSubview {
		public void setup();
		public String generateYenURLTag();
		public void resetAll();
		public void validate();
    }
}
